#include "ti86asm.inc"
#include "ti86math.inc"
_dispOP1	.EQU	515Bh
_ioprompt	.equ	$c324
_asap_ind	.equ	$d623
_fracOP1	.EQU	4B93h

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Radian / Degree Converter",0
Title:
	.db "                    "
	.db "Radian / Degree Converter",0
keys:
	.db "      ",6,"  ",7," move    ENTER   select    EXIT   quits",0
line1:
	.db " Radians to Degrees",0
line2:
	.db " Degrees to Radians",0
Author:
	.db "    Adam Martin  -  fjhatch@access1.net  ",0 
ProgStart:
	call _clrLCD
	ld hl,$0100
	ld (_penCol),hl
	call Top7Invert
	ld hl,Title
	call Drw
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,line1
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,line2
	call _vputs
	ld hl,$3200
	ld (_penCol),hl
	ld hl,Author
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,keys
	call _vputs
	call B7Black
	ld c,2
DoMenuDTL:
	ld a,d								;Get The Vertical Coord
	add a,7								;Move To Next Line
	ld d,a								;Save New Coord
	djnz DoMenuDTL						;Draw All The Text
	ld b,1								;Start Menu At First Entry
	call DoMenuInvBar					;Invert It
DoMenuL:
	push bc								;Save Entries And Current Entry
	call _getky						 	;Read Key Presses
	pop bc								;Restore It
	cp K_UP								;Did They Press Up?
	jr z,DoMenuUp						;Move Menu Bar Up
	cp K_EXIT
	jp z,Exit
	cp K_DOWN							;Or Was It Down?
	jr z,DoMenuDown
	cp K_ENTER
	jr z,RDorDR						;Then Move The Bar Down
	jr DoMenuL							;They're Just Sitting There, Loop Again
DoMenuUp:
	call DoMenuInvBar					;Invert Current Selection Back To Normal
	dec b								;Move Up
	jr nz,DoMenuBar
	ld b,1
	jr DoMenuBar						;Handle Menu Bar
DoMenuDown:
	call DoMenuInvBar					;Same As Up, Go Back To Normal Text
	ld a,c
	cp b								;At The Bottom?
	jr z,DoMenuDownT					;Then Move To The Top								;Get Current Entry For Check
	inc b								;Move Down
	jr DoMenuBar						;Handle Menu Bar
DoMenuDownT:
	ld b,2								;Move To The Top
DoMenuBar:
	call DoMenuInvBar					;Invert The New Selection
	jr DoMenuL							;Now It's Time To Loop
DoMenuInvBar:
	push bc								;Save Position And Entries
	ld h,b								;Get Position
	ld l,112							;There Are 7 Lines Of 16 Bytes Each (7*16 = 112)
	call _HtimesL						;Do The Multiply
	ld de,$fc70 							;We Need To Add To Video Memory
	add hl,de							;Do The Add
	call DoMenuInv						;Invert The Line
	pop bc								;Restore Position And Entries
	ret									;Done Inverting
DoMenuInv:
	ld b,7*16							;Each Row Is 16 Bytes Wide And Text Is 7 Rows High
DoMenuIL:
	ld a,(hl)							;Get The Byte
	cpl						 			;NOT The Byte--Flips All The Bits
	ld (hl),a							;Save The New Byte
	inc hl								;Next Byte
	djnz DoMenuIL						;Loop For All Bytes
	ret						 			;We're Done With The Invert Loop
Exit:
	call _clrLCD
	call _homeup
	ret
Top7Invert:
	call _clrLCD
	ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,111
    ldir
    set  3,(iy+05)
    ld   de,$0001
    ld   (_penCol),de
    ret
Drw:
    call _vputs
    res  3,(iy+05)
	ret
B7Black:
    ld b,112
    ld hl,$FF90
Draw1:
    ld a,(hl)
    cpl
    ld (hl),a
    inc	hl
    djnz Draw1
	ret
RDorDR:
	ld a,c
	cp b								;At The Bottom?
	jr z,D2R
	jr nz,R2D
	
NumPrompt:
	.db Lpi," Radians:",0
Degrees:
	.db "  Degrees:           ",0
fracbar:
	.db "Coefficient of ",Lpi," = --",0
R2D:
	call _clrLCD
	ld hl,$0000
	ld (_curCol),hl
	ld (_curRow),hl
	ld hl,NumPrompt
	ld de,_ioprompt
	ld bc,11
	ldir
	ld a,0Dh
	ld (_asap_ind),a
	call _exec_pg3
	ld hl,$B4
	call _setXXXXop2
	call _FPMULT
	call _clrLCD
	call _homeup
	ld hl,Degrees
	call _puts
	call _dispOP1
	call _pause
	jp Exit
D2R:
	call _clrLCD
	ld hl,$0000
	ld (_curCol),hl
	ld (_curRow),hl
	ld hl,Degrees
	ld de,_ioprompt
	ld bc,9
	ldir
	ld a,0Dh
	ld (_asap_ind),a
	call _exec_pg3
	ld hl,$B4
	call _setXXXXop2
	call _FPDIV
	call _fracOP1
	call _dispOP1
	ld hl,fracbar
	call _puts
	call _op2toop1
	call _dispOP1
	call _pause
	jp Exit

	